%sfera galleggiante

r=5;
s=0.65;
c=[1 -3*r 0 4*(r^3)*s];
d=roots(c);
d_pos=d(d>0 & d<2*r);

x=linspace(0,10,200);
y=pi*polyval(c,x)/3;

figure;
plot(x,y,d_pos,0,'r*',[0 10],[0 0],'k')
legend('polinomio p(d)','radice accettabile')
title('polinomio p(d) con r=5 cm e s=0.65')
xlabel('d')
ylabel('p(d)')

fprintf('La profondit d per cui  immersa la sfera con s=0.65  %f.\n\n',d_pos)


% radice scelta 6.0139

%seconda parte
s=0.01:0.01:1;
for k=1:length(s)
    c=[1 -3*r 0 4*(r^3)*s(k)];
    d=roots(c)
    dpos(k)=min(d(d>0 & d<=2*r));
end
I=find(dpos>r);
fprintf('Per valori di s compresi in [%1.1f,%1.1f] la sfera galleggia con il centro\n sotto la superficie dell''acqua\n',s(min(I)),s(max(I)))
% la sfera galleggia con il centro sotto la superficie 
% dell'acqua (d>r) per 0.5 < s < 1
% per s=0.5 si ha esattamente d=r;
