% funzione 1
fun1 = @(x)10*x(1)^2 + x(2)^2;

x = fminsearch(fun1,[1,2])
xnr = newton(@dfun_min1,@ddfun_min1,[1,2]',1e-4)
% Grafico della funzione e linee di livello
figure(1)
a=-5;b=5;
[X,Y]=meshgrid(a:0.1:b,a:0.1:b);
Z = 10*X.^2 + Y.^2;
surfc(X,Y,Z)
hold on
plot3(xnr(1),xnr(2),0,'r*', 'MarkerSize',10)
plot3(xnr(1),xnr(2),fun1(xnr),'ko', 'MarkerSize',10)
pause

% funzione 2
fun2 = @(x)(x(1)-2)^4 + (x(1)-2)^2*x(2)^2 + (x(2)+1)^2; 
x = fminsearch(fun2,[1,1])
xnr = newton(@dfun_min2,@ddfun_min2,[1,1]',1e-4)
% Grafico della funzione e linee di livello
figure(2)
a=-10;b=10;
[X,Y]=meshgrid(a:0.1:b,a:0.1:b);
Z=(X - 2).^4 + (X - 2).^2.*Y.^2 + (Y + 1).^2;
surfc(X,Y,Z)
hold on
plot3(xnr(1),xnr(2),0,'r*', 'MarkerSize',10)
plot3(xnr(1),xnr(2),fun2(xnr),'wo', 'MarkerSize',10)
